module ScrabbleScore
  class Letters
    TILE_VALUES = {
      'a' => 1, 'b' => 3, 'c' => 3, 'd' => 2, 'e' => 1, 'f' => 4,
      'g' => 2, 'h' => 4, 'i' => 1, 'j' => 8, 'k' => 5, 'l' => 1,
      'm' => 3, 'n' => 1, 'o' => 1, 'p' => 3, 'q' => 10, 'r' => 1,
      's' => 1, 't' => 1, 'u' => 1, 'v' => 4, 'w' => 4, 'x' => 8,
      'y' => 4, 'z' => 10
    }

    attr_reader :word

    def initialize(word)
      @word = Letters.cleanse(word)
    end

    def permutations
      permutation_array = []
      letter_array = @word.split(//)

      (2..letter_array.size).each do |length|
        letter_array.permutation(length).each do |perm|
          permutation_array << perm.join
        end
      end
      permutation_array.uniq
    end

    def score
      score = 0
      @word.downcase.each_char { |ch| score += TILE_VALUES[ch] }
      score
    end

    def self.cleanse(word)
      word.downcase.gsub(/[^a-z]/, '')
    end
  end
end